import abc
from typing import Any

from ..util import ABC as ABC

class ConnectionCharacteristic(ABC, metaclass=abc.ABCMeta):
    transactional: bool = ...
    @abc.abstractmethod
    def reset_characteristic(self, dialect: Any, dbapi_conn: Any) -> Any: ...
    @abc.abstractmethod
    def set_characteristic(
        self, dialect: Any, dbapi_conn: Any, value: Any
    ) -> Any: ...
    @abc.abstractmethod
    def get_characteristic(self, dialect: Any, dbapi_conn: Any) -> Any: ...

class IsolationLevelCharacteristic(ConnectionCharacteristic):
    transactional: bool = ...
    def reset_characteristic(self, dialect: Any, dbapi_conn: Any) -> None: ...
    def set_characteristic(
        self, dialect: Any, dbapi_conn: Any, value: Any
    ) -> None: ...
    def get_characteristic(self, dialect: Any, dbapi_conn: Any): ...
